/* crhash -- create and initialize an empty hash file
 *		used to hold part database records
 */
#include "local.h"
#include "part.h"
#include "rec_io.h"

main(ac, av)
	int ac;
	char *av[];
	{
	rec_fd fd;			/* record file descriptor */
	short size;			/* size of one record in created file */
	long nrecs;			/* maximum numbers of records in created file */
	char *buf;			/* data to init. each record */
	long i;				/* counter to write records in created file */

	if (ac != 4)
		error("usage: crhash filename nrecs recsize", "");

	nrecs = atol(av[2]);
	size = atoi(av[3]);
	fd = rec_open(av[1], O_RDONLY, size);
	if (fd > 0)
		{
		rec_close(fd);
		error("file already exists:", av[1]);
		}

	fd = rec_open(av[1], O_RDWR|O_CREAT, size);
	if (fd < 0)
		error("can't create file", av[1]);

	buf = (char *)calloc(size, 1);
	if (buf == NULL)
		error("Need more heap space to allow size =", av[3]);
	*buf = REC_AVAIL;
	/* file was created ok, initialize file */
	for (i = 0; i < nrecs; ++i)
		{
		if (!rec_put(fd, buf, REC_W_END))
			error("I/O error writing new file", "");
		}
	rec_close(fd);
	exit(SUCCEED);
	}
